(function($) {
  Drupal.behaviors.jqueryUIFormInit = { 
      attach: function(context) {
        var opts = {};
        // Fieldset is attached using modified collapse.js
        
        // Buttons
        $('input.form-submit').once('submit').Fhover();
        $('a.button').once('a.button').Fhover();
        $('input.form-button').once('fbutton').Fhover();
        $('input.form-image_button').once('ibutton').Fhover();
              
        // Textfield
        $('input.form-text').once('textfield').input();
        
        // Textarea
        $('textarea').once('textarea').input();
        
        // Select box
        $('select').once('select').input();
        
        // Vertical tabs
        $('.vertical-tabs').once('vtabs').verticaltabs();         
        
        // Password confirm
        $('.form-type-password-confirm').once('password').password();
        
        // Checkbox
        // Not stable, so it is removed for now
        // $('input.form-checkbox').checkbox();
        
        // Radio
        // Not stable, so it is removed for now
        // $('input.form-radio').radiobutton();
     }
   };
  
  /**
   * Altering autocomplete to play nice with jQuery UI.
   */
  if (Drupal.jsAC) {
    Drupal.jsAC.prototype.populatePopup = function () {
      var $input = $(this.input);
      var position = $input.position();
      // Show popup.
      if (this.popup) {
        $(this.popup).remove();
      }
      this.selected = false;
      this.popup = $('<div id="autocomplete"></div>')[0];
      this.popup.owner = this;
      $(this.popup).css({
        top: parseInt(position.top + this.input.offsetHeight, 10) + 'px',
        left: parseInt(position.left, 10) + 'px',
        width: $input.innerWidth() + 'px',
        display: 'none'
      }).addClass('ui-corner-all ui-widget-content');
   
      $input.before(this.popup);
  
      // Do search.
      this.db.owner = this;
      this.db.search(this.input.value);
    };
  }
  
  $.fn.input = function (options) {
    var defaults = {
        hoverClass: 'ui-state-hover',
        focusClass: 'ui-state-focus',
        activeClass: 'ui-state-active',
        disabledClass: 'ui-state-disabled',
        baseClass: 'ui-widget-content ui-corner-all'
    };
    
    options = $.extend(defaults, options);
    
    return this.each(function() {
      var self = $(this);
      
      // Check activer state
      options.disabled = self.is(':disabled');
      
      if (options.disabled == true) {
        self.addClass(options.disabledClass);
        return;
      }
      // Make all fonts the same non-bold
      self.css('font-weight', 'normal');
      
      // Register hover function
      self.hover(function() {
        $(this).addClass(options.hoverClass);
      }, function() {
        $(this).removeClass(options.hoverClass);
      });

      self.click(function() {
        $(this).addClass(options.activeClass);
        $(this).removeClass(options.hoverClass);
      });
      
      self.focusout(function() {
        $(this).removeClass(options.activeClass);
      });
      
      self.focus(function() {
        $(this).addClass(options.focusClass);
      });
      
      self.blur(function() {
        $(this).removeClass(options.focusClass);
      });
      
      self.mousedown(function() {
        $(this).addClass(options.activeClass);
      });
      
      self.mouseup(function() {
        $(this).removeClass(options.activeClass);
      });
    });
  };

  /**
   * Plugin for changing class according
   * to jQueryUI specification
   */
  $.fn.Fhover = function (options) {
    var defaults = {
        hoverClass: 'ui-state-hover'
    };
    
    options = $.extend(defaults, options);
    
    return this.each(function() {
      $(this).hover(function() {
        $(this)
        .toggleClass(options.hoverClass);
      }, function() {
        $(this)
        .toggleClass(options.hoverClass);
      });
    });
  };
  
  
  /**
   * Plugin for formatting drupal password fields
   */
  $.fn.password = function (options) {
    var defaults = {
        suggestionClass: 'ui-corner-all ui-state-error ui-widget-content',
        indicatorClass: 'ui-widget ui-widget-content ui-corner-all',
        indicatorContentClass: 'ui-progressbar-value ui-widget-header ui-corner-all'
    };

    options = $.extend(defaults, options);

    return this.each(function(context) {
      var self = $(this);
      
      self.find('.password-suggestions')
          .removeClass('description')
          .addClass(options.suggestionClass);
      
      self.find('.password-indicator')
          .addClass(options.indicatorClass)
          .children('.indicator')
          .addClass(options.indicatorContentClass);
    });
  };
  
  /**
   * Plugin for formatting fieldset to be compatible
   * with jQueryUI and still honour Drupal collapsible
   * state.
   */
  $.fn.fieldset = function (options, context) {
    var defaults = {
        openClass: 'ui-corner-top ui-state-active ui-no-border-bottom',
        closeClass: 'ui-corner-all ui-state-default ',
        hoverClass: 'ui-state-hover',
        iconOpen: 'ui-icon-triangle-1-s',
        iconClose: 'ui-icon-triangle-1-e',
        iconNotCollapsible: 'ui-icon-bullet',
        wrapperClass: 'ui-widget-content ui-corner-bottom'
    };

    options = $.extend(defaults, options);

    return this.each(function(context) {
      var self = $(this, context),
          legend = self.children('legend'),
          fieldsetWrapper = self.children('.fieldset-wrapper'),
          fieldwidth = fieldsetWrapper.outerWidth();
      // Check if fieldset is collapsible
      options.collapsible = self.hasClass('collapsible');
      options.collapsed = self.hasClass('collapsed');
      
      // Fieldset is collapsible and in collapsed state
      if (options.collaspsible == true && options.collapsed == true) {
        legend.addClass(options.closeClass).find('.ui-icon').addClass(options.iconClose);
      }
      
      // Fieldset is collapsible and not in collapsed state
      if (options.collaspsible == true && options.collapsed == false) {
        legend.addClass(options.openClass).find('.ui-icon').addClass(options.iconOpen);
      }
      
      // Fieldset is not collapsible
      if (options.collaspsible == false) {
        legend.addClass(options.openClass).find('.ui-icon').addClass(options.iconNotCollapsible);
      }
      
      fieldsetWrapper.addClass(options.wrapperClass);
           
      // Bind click function
      // Hijacking the collapse.js open and collapse function
      legend.find('.fieldset-title').unbind('click').bind('click' , function() {     
        if (options.collapsible == true) {
          var fieldset = $('#' + self.attr('id')).get(0);
             
          if (!fieldset.animating) {
            // Toggle classes
            $(this)
              .parents('legend')
              .eq(0)
              .toggleClass(options.openClass)
              .toggleClass(options.closeClass)
              .find('.ui-icon')
              .toggleClass(options.iconOpen)
              .toggleClass(options.iconClose);     

          
            // Don't animate multiple times.
            fieldset.animating = true;
            Drupal.toggleFieldset(fieldset);
          }
          return false;
        }
      });
      
      // Bind mousehover
      legend.bind('mouseenter', function() {
        $(this).addClass(options.hoverClass);
      }).bind('mouseout', function() {
        $(this).removeClass(options.hoverClass);
      });
      
      // Loop to children fieldset
      self.find('fieldset').fieldset();
  
    });    
  };
  
  /**
   * Function to resize fieldset so it wont
   * overflow the parent width.
   * This function depends on parent width
   * set correctly, auto width wont work
   * need parent to have static size
   */
  $.fn.fieldsetResize = function (options) {
    var defaults = {
        processChildren: true
    };
    
    options = $.extend(defaults, options);
    
    return this.each(function() {
      var self = $(this),
          containerWidth = self.parent().width();
          selfPadding = parseInt(self.css('padding-left')) + parseInt(self.css('padding-right')),
          legendPadding = parseInt(self.children('legend').css('padding-left')) + parseInt(self.children('legend').css('padding-right')),
          wrapperPadding = parseInt(self.children('.fieldset-wrapper').css('padding-left')) + parseInt(self.children('.fieldset-wrapper').css('padding-right'));
      
      self.width(containerWidth - selfPadding);
      self.children('legend').width(containerWidth - selfPadding - legendPadding);
      self.children('.fieldset-wrapper').width(containerWidth - selfPadding - wrapperPadding);
      
      if (options.processChildren) {
        var childopts = {
          fieldsetSize : containerWidth - selfPadding - wrapperPadding
        };
        self.fieldsetContentResize(childopts);
      }
    });
  };
  
  /**
   * Function to resize the input form text
   * and select under a fieldset so it wont
   * overflow the fieldset width.
   */
  $.fn.fieldsetContentResize = function(options) {
    var defaults = {
        fieldsetSize: 0
    };
    
    options = $.extend(defaults, options);
    
    return this.each(function() {
      var self = $(this);
      
      if (options.fieldsetSize == 0) {
        return false;
      }
      
      // Process input form text
      self.find('input.form-text').each(function() {
        var inputPadding = parseInt($(this).css('padding-left')) + parseInt($(this).css('padding-right')),
            maxWidth = options.fieldsetSize - inputPadding;
        
        $(this).css({'max-width' : maxWidth });
        
      });
      
      // Process form select
      self.find('input.form-select').each(function() {
        var inputPadding = parseInt($(this).css('padding-left')) + parseInt($(this).css('padding-right')),
            maxWidth = fieldsetSize - inputPadding;
        $(this).css({'max-width' : maxWidth });        
      });

    });
  };    
  
  /**
   * Function to reset fieldset, legend and fieldset wrapper
   * style attributes
   */
  $.fn.fieldsetResetStyle = function() {
    return this.each(function() {
      var self = $(this);
      
      self.removeAttr('style')
          .find('legend').removeAttr('style');
      self.find('.fieldset-wrapper').removeAttr('style');
    });   
  };
  
  /**
   * Plugin to format vertical tabs according to jQueryUI format
   */
  $.fn.verticaltabs = function (options) {
    var defaults = {
        wrapperClass: 'ui-widget-content ui-corner-all',
        hoverClass: 'ui-state-hover',
        tabClass: 'ui-widget-header ui-no-border-top',
        activeTabClass: 'ui-widget-content ui-no-border-right'
    };
    
    options = $.extend(defaults, options);
    
    return this.each(function() {
      var self = $(this),
          tabList = self.find('.vertical-tab-button');
        
      // Initialization
      self.addClass(options.wrapperClass)
          .find('.vertical-tab-button:not(.selected)').addClass(options.tabClass)
          .find('.selected').addClass(options.activeTabClass);
      
      self.find('.vertical-tab-button.last').addClass('ui-corner-bl');
      self.find('.vertical-tab-button.first').addClass('ui-corner-tl');
      self.find('.vertical-tabs-list').addClass('ui-corner-left');
      
      // Remove first legend and .fieldset-wrapper
      self.children('.vertical-tabs-panes')
          .children('fieldset')
          .children('legend')
          .hide()
          .next()
          .removeClass('ui-widget-content');
      
      // Register click function
      self.find('.vertical-tab-button a').click(function(e) {         
        $(this).parent()
               .removeClass(options.tabClass)
               .addClass(options.activeTabClass);
        
        // Resetting all other element
        self
          .find('.vertical-tab-button:not(.selected)')
          .addClass(options.tabClass)
          .removeClass(options.activeTabClass);
    
        e.preventDefault(); 
      });
      
      
      // Register hover function
      self.find('.vertical-tab-button').hover(function() {
        $(this).addClass(options.hoverClass);
      }, function() {
        $(this).removeClass(options.hoverClass);
      });

    });
  };
})( jQuery );
